//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TImageList ̉摜 TBitmap.Canvas ɒڕ`
//  TImageList.Draw \bhgp
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2019N0826 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ExtCtrls, Vcl.ImgList;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    ImageList1: TImageList;
    ImageList2: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    FBackImgPath : string;
    procedure DrawBackGroundImage(ACanvas: TCanvas; AFilePath: string);
  end;

  procedure SetBitmapAlpha(ABitmap: TBitMap);

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//  ߏԂ̊mFpɔwiwFœhׂ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Color   := $00B3FFB3;
  FBackImgPath := ExpandFileName('..\BackTexture_01.bmp');
end;

//=============================================================================
//  TImageList ̉摜 TBitmap.Canvas ɒڕ`
//  TImageList.Draw \bhgp
//
//  TBitmap.Canvas ɕ`悷ꍇ
//  TImageList.Draw ŕ`悷OɊSɓ TBitmap ɂĂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LBitmap : TBitmap;
begin
  Image1.Picture.Assign(nil);
  Image2.Picture.Assign(nil);

  //ߏԂ悤ɔwiɎs͗l̃rbg}bv摜`
  DrawBackGroundImage(Image1.Canvas, FBackImgPath);
  DrawBackGroundImage(Image2.Canvas, FBackImgPath);


  LBitmap := TBitmap.Create;
  try
    LBitmap.AlphaFormat := afDefined;

    LBitmap.SetSize(Image1.Width * ImageList1.Count, Image1.Height);
    if ImageList1.ColorDepth = cd32Bit then begin
      SetBitmapAlpha(LBitmap);
    end;

    ImageList1.Draw(LBitmap.Canvas, 0, 0, 0);
    ImageList1.Draw(LBitmap.Canvas, ImageList1.Height, 0, 1);

    Image1.Picture.Assign(LBitmap);
    Image2.Canvas.Draw(0, 0, LBitmap);
  finally
    FreeAndNil(LBitmap);
  end;
end;

//----------------------------------------------------------------------------
//  TImage ̔wiƂĎs͗l̃uV`
//  TBitmap ̓ߐFƔF̊mFp
//  ̖͗l镔͓܂͔̕ƂƂɂȂ
//----------------------------------------------------------------------------
procedure TForm1.DrawBackGroundImage(ACanvas: TCanvas; AFilePath: string);
var
  LBmpBack : TBitmap;
begin
  LBmpBack := TBitmap.Create;
  try
    LBmpBack.LoadFromFile(AFilePath);
    ACanvas.Brush.Style  := bsSolid;
    ACanvas.Brush.Bitmap := LBmpBack;
    ACanvas.FillRect(ACanvas.ClipRect);
  finally
    FreeAndNil(LBmpBack);
  end;
end;

//----------------------------------------------------------------------------
//  ȃrbg}bv摜̍쐬
//  At@`l̃rbg}bṽsNZl̃NA
//  Red,Gree, Blue, Alphi lS0 ɂrbg}bvɂ
//----------------------------------------------------------------------------
procedure SetBitmapAlpha(ABitmap: TBitMap);
type
  TRGBQArray = array [0..High(Integer) div 4 - 1] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LPosY      : Integer;
  LPosX      : Integer;
  LScanArray : PRGBQArray;
begin
  ABitmap.Canvas.Lock;
  ABitmap.PixelFormat := pf32bit;

  for LPosY := 0 to ABitmap.Height - 1 do begin
    LScanArray := ABitmap.ScanLine[LPosY];
    for LPosX  := 0 to ABitmap.Width - 1 do begin
      LScanArray[LPosX].rgbRed      := 0;
      LScanArray[LPosX].rgbGreen    := 0;
      LScanArray[LPosX].rgbBlue     := 0;
      LScanArray[LPosX].rgbReserved := 0;
    end;
  end;

  ABitmap.Canvas.Unlock;
end;

end.
